;-- TIME_STAMP   2017-10-07 15:02:37   v 0.1

#Region ;************ Includes ************
#include <GUIConstantsEx.au3>
;~ #include <WindowsConstants.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <GDIPlus.au3>
;~ #include <WinAPI.au3>
#EndRegion ;************ Includes ************

Global $g_hImageList

_GDIPlus_Startup()

Example()

_GDIPlus_Shutdown()

Func Example()
	Local $idListview, $iStylesEx = BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES)

	GUICreate("ImageList Add", 400, 486)
	$idListview = GUICtrlCreateListView("", 2, 2, 394, 484, BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER, $LVS_REPORT))
	_GUICtrlListView_SetExtendedListViewStyle($idListview, $iStylesEx)
	GUISetState(@SW_SHOW)

	; Load images
	Local $iX = 64, $iY = 64
;~ 	Local $iX = 32, $iY = 32
;~ 	Local $iX = 16, $iY = 16
	$g_hImageList = _GUIImageList_Create($iX, $iY, 5)
	_GUIImageList_Add($g_hImageList, _GUICtrlListView_CreateSolidBitMap($idListview, 0xFF0000, $iX, $iY))
	_GUIImageList_Add($g_hImageList, _GUICtrlListView_CreateSolidBitMap($idListview, 0x00FF00, $iX, $iY))
	_GUIImageList_Add($g_hImageList, _GUICtrlListView_CreateSolidBitMap($idListview, 0x0000FF, $iX, $iY))

	_GUIImageList_AddIcon($g_hImageList, @ScriptDir & '\note.ico', 0, True)
	_GUIImageList_AddImage($g_hImageList, @ScriptDir & '\note.png', $iX, $iY)
	_GUIImageList_AddImage($g_hImageList, @ScriptDir & '\note.gif', $iX, $iY)
	_GUIImageList_AddImage($g_hImageList, @ScriptDir & '\Andere_Sorgen.jpg', $iX, $iY)

	_GUICtrlListView_SetImageList($idListview, $g_hImageList, 1)

	; Add columns
	_GUICtrlListView_AddColumn($idListview, "Items", 120)
	_GUICtrlListView_AddColumn($idListview, "SubItems", 150)
	_GUICtrlListView_AddColumn($idListview, "Comment", 120)

	Local $aComment = ['SolidBitMap', 'SolidBitMap', 'SolidBitMap', 'ICO', 'PNG', 'GIF', 'JPG']
	For $i = 0 To 6 Step 1
		; Add items
		_GUICtrlListView_AddItem($idListview, "Item " & $i, $i)
		; Add subitems
		_GUICtrlListView_AddSubItem($idListview, $i, "SubItem " & $i, 1, $i)
		_GUICtrlListView_AddSubItem($idListview, $i, $aComment[$i], 2, -1)
	Next

	; Loop until the user exits.
	Do
	Until GUIGetMsg() = $GUI_EVENT_CLOSE
	GUIDelete()
EndFunc   ;==>Example

Func _GUIImageList_AddImage($hImageList, $sImage, $iX, $iY)
	Local $a_hBitmap[2]
	; Create 32 bits-per-pixel bitmap from a PNG image
	Local $hImage = _GDIPlus_ImageLoadFromFile($sImage)
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   var: $hImage --> " & $hImage & @CRLF)
	$hImage = _GDIPlus_ImageResize($hImage, $iX, $iY)
	$a_hBitmap[0] = _GDIPlus_BitmapCreateDIBFromBitmap($hImage)
	_GDIPlus_ImageDispose($hImage)
	$a_hBitmap[1] = _WinAPI_CreateANDBitmap($a_hBitmap[0])
	$iImg = _GUIImageList_AddMasked($g_hImageList, $a_hBitmap[0], $a_hBitmap[1])
;~ 	$iImg = _GUIImageList_Add($g_hImageList, $a_hBitmap[0], $a_hBitmap[1])
	_WinAPI_DeleteObject($a_hBitmap[0])
	_WinAPI_DeleteObject($a_hBitmap[1])
EndFunc   ;==>_GUIImageList_AddImage
